if (params.keep_intermediate >= 4) {
  publishdir_enabled = true
} else {
  publishdir_enabled = false
}

process MERGE_TRUST4_CHUNKS {
  publishDir "${params.outdir}/trust4/${sample}/${isotype}", mode: "copy", enabled: true, pattern: "TRUST4_{cdr3.out,annot.fa,airr_align.tsv}"
  publishDir "${params.outdir}/trust4/${sample}/${isotype}", mode: "copy", enabled: publishdir_enabled
  tag "Sample:$sample Isotype:$isotype"

  input:
  tuple val(sample), val(isotype), val(has_header), val(filename), path(trust4_chunk_files)

  output:
  tuple val(sample), val(isotype), path(filename)

  script:
  def first_file = trust4_chunk_files[0]

  if ( has_header == "false") {
    """
    cat $trust4_chunk_files > ${filename}
    """
  } else if ( has_header == "true" ) {
    """
    head -n1 ${first_file} > ${filename}
    for FILE in ${trust4_chunk_files}; do
      tail -n +2 \$FILE >> ${filename}
    done
    """
  } else
    error "Invalid header status: ${has_header}"
}
