process PLOT_UMI_GROUP_FREQUENCIES {
  conda "${projectDir}/share/config/env/plot_umi_group_frequencies.yaml"
  publishDir "${params.outdir}/umi_stats", mode: "copy"
  tag "Sample:$sample"

  input:
  tuple val(sample), path(umi_group_sizes_frequency_csv_files)

  output:
  tuple val(sample), path("umi_group_sizes_frequency.*.png"), path(".command.*"), optional: true

  shell:
  if (params.use_umis && params.kit_uses_umi) {
    '''
    Rscript !{projectDir}/share/scripts/plot-umi-group-sizes-frequency.R !{sample} !{umi_group_sizes_frequency_csv_files}
    '''
  }
}
