process SPLIT_METADATA_BY_SAMPLE {
  tag "Sample:$sample"

  input:
  tuple val(metadata_dir_absolute_path), val(sample), val(fastq1), val(fastq2), val(is_read1_file_name_absolute_path), val(is_read2_file_name_absolute_path)

  output:
  tuple val(sample), path("metadata.csv")

  shell:
  fastq1_absolute_path = is_read1_file_name_absolute_path ? fastq1 : "${metadata_dir_absolute_path}/${fastq1}"
  fastq2_absolute_path = is_read1_file_name_absolute_path ? fastq2 : "${metadata_dir_absolute_path}/${fastq2}"
  """
  echo "sampleID,read1_file_name,read2_file_name" > metadata.csv
  echo "${sample},${fastq1_absolute_path},${fastq2_absolute_path}" >> metadata.csv
  """
}
