def check_dir(d, exp):
    if os.path.isdir(d) is False:
        print(get_time() + ' [ERROR] ' + d + ' ' + exp, flush=True)
        sys.exit(1)
    else:
        return True


def check_file(f, exp):
    if os.path.isfile(f) is False:
        print(get_time() + ' [ERROR] ' + f + ' ' + exp, flush=True)
        sys.exit(1)
    else:
        return True


def timer(start_time):
    end_time = datetime.datetime.now()
    script_time = end_time - start_time
    secs = round(script_time.total_seconds() % 60, 2)
    mins = int(script_time.total_seconds() // 60) % 60
    hour = int(script_time.total_seconds() // 3600)
    diff = ':'.join([str(hour) + 'h', str(mins) + 'm', str(secs) + 's'])
    return diff


def ham_check(hh, bc):
    try:
        return hh[bc]
    except KeyError:
        return ''


# pre: prs[0] and bc should be same length
def ham_check2(prs, bc):
    if bc.find('GGGGG') >= 0:
        return ''
    errbs = int(len(bc)//2.75)
    seqs = list(prs.keys())
    if bc=='CCAGTGGATAG' or bc=='CCAAGGGATAG' or bc=='CCAGTAGATAG' or bc == 'AGGGACCAAGG':
        print('bc=', bc)
    for i in range(len(seqs)):
        # when no insert/delete
        seq = seqs[i]
        mappedseq = get_errorbs_bytwoseqs(bc, seq, errbs)
        if len(mappedseq) == 0 and ((bc=='AGGGACCAAGG' and seq=='AGTGGATAGAC') or (bc=='CCAGGGACCAAGG' and seq=='CCAGTGGATAGAC')):
            mappedseq = seq
        if len(mappedseq)>0:
            return mappedseq
        else:
            # when 1b delete, errbs-1
            for delnum in range(1,3):
                errbsx = errbs - delnum
                for deleteid in range(len(bc)-delnum):
                    bcx = bc[:deleteid]+bc[deleteid+delnum:len(bc)]
                    seqx = seq[:len(seq)-delnum]
                    mappedseq = get_errorbs_bytwoseqs(bcx, seqx, errbsx)
                    if len(mappedseq)>0:
                        return seq
            # when 1b insert, errbs-1
            errbsx = errbs
            for insnum in range(1,errbs+3):
                Nstr = ''
                for id in range(insnum):
                    Nstr += 'N'
                if insnum > 3:
                    errbsx = insnum
                for insertid in range(len(bc)-insnum):
                    bcx = bc[:insertid] + Nstr + bc[insertid:len(bc)-insnum]
                    mappedseq = get_errorbs_bytwoseqs(bcx, seq, errbsx)
                    if len(mappedseq)>0:
                        return mappedseq
                    if insnum == 2:
                        for nextN in range(insertid+1,len(bc)-2):
                            bcx = bc[:insertid] + 'N' + bc[insertid:nextN] + 'N' + bc[nextN:len(bc)-insnum]
                            mappedseq = get_errorbs_bytwoseqs(bcx, seq, errbsx)
                            if len(mappedseq)>0:
                                return mappedseq
    return ''


def get_subigindex(lines, p_s, p_e, umi):
    pos = -1
    mid = int((p_s + p_e)/2)
    mid = (mid//4)*4

    if p_e > p_s :
        myumi = lines[mid+1][:12]
        if umi > myumi:
            pos = get_subigindex(lines, mid, p_e, umi)
        elif umi < myumi:
            pos = get_subigindex(lines, p_s, mid, umi)
        else: # umi == myumi
            pos = mid
    return pos


def get_umi_index(lines, pos):
    umi = lines[pos+1][:12]
    line = lines[pos].split()[0]
    segs = line.split(":")
    l = len(segs)
    return [umi, int(segs[l-3]), int(segs[l-2]), int(segs[l-1])]


def do_merge2(read2, r2):
    return read2


def do_merge1(read1, ref_subr1, pos):
    with open(ref_subr1, "r") as fr:
         lines = fr.readlines()
    r1 = lines[pos:pos+4]
    read1 = do_merge2(read1, r1)
    return read1


def merge_subIG_head(numl, fr1, fr2, sample, subseq, read1, read2, repo_type, species, pseq_dict, prs, len_cutoff=30, mismatch=1):
    infos = get_umi_index(read2, 0)
    lines2 = []
    lines1 = []
    for i in range(4):
         lines2.append(fr2.readline())
         lines1.append(fr1.readline())
    myinfos = get_umi_index(lines2, 0)
    #pos = get_subigindex(lines, 0, len(lines)-1, infos[0])
    while myinfos[0] < infos[0]:
        lines2.clear()
        lines1.clear()
        for i in range(4):
             lines2.append(fr2.readline())
             lines1.append(fr1.readline())
        myinfos = get_umi_index(lines2, 0)

    if myinfos[0] < infos[0]:
        print("exact same to do merging")
    elif myinfos[0] > infos:
        print("give to do merging")
    elif myinfos[0] == infos:
        print("exact same to do merging")
        do_merge2(read2, lines2)
        do_merge2(read1, lines1)
    else:
        print("get most similar r2")
    return read1, read2


def merge_subIG_mid(sample, subseq, read1, read2, repo_type, species, pseq_dict, prs, len_cutoff=30, mismatch=1 ):
    ref_subr1 = os.path.join(p_args.out_dir, "preprocess", sample+"_subIGG_R1_sorted.fastq")
    ref_subr2 = os.path.join(p_args.out_dir, "preprocess", sample+"_subIGG_R2_sorted.fastq")
    if subseq == "GGGAAGA":
        ref_subr1 = os.path.join(p_args.out_dir, "preprocess", sample+"_subIGA_R1_sorted.fastq")
        ref_subr2 = os.path.join(p_args.out_dir, "preprocess", sample+"_subIGA_R2_sorted.fastq")
    infos = get_umi_index(read2, 0)
    with open(ref_subr2, "r") as fr:
         lines = fr.readlines()
    pos = get_subigindex(lines, 0, len(lines)-1, infos[0])
    if pos >=0 and pos < len(lines):
        while get_umi_index(lines, pos) < infos:
            pos += 4
        while get_umi_index(lines, pos) > infos:
            pos -= 4

        if get_umi_index(lines, pos) < infos:
            pos += 4
        elif get_umi_index(lines, pos) > infos:
            pos -= 4
        elif get_umi_index(lines, pos) == infos:
            print("exact same to do merging")
        else:
            print("get most similar r2")
        do_merge2(read2, lines[pos:pos+4])
        do_merge1(read1, ref_subr1, pos)
    else:
        print("have no the corresponding the sub r2; give up")
    return read1, read2


def save_sortedfastq(umis, r1_fq, r2_fq, p_args):
    for key in range(2):
        fpath = r2_fq
        if key == 1:
            fpath = r1_fq
        fdname = os.path.dirname(fpath)
        fname = os.path.basename(fpath)
        fname_sorted = fname.replace(".fastq", "_sorted.fastq")
        with open(fpath, "r") as fr:
            lines = fr.readlines()
        with open(os.path.join(fdname, fname_sorted), 'w') as fw:
            ncols = len(umis[0])
            for i in range(len(umis)):
                index = umis[i][ncols-1]
                for j in range(4):
                    fw.write('%s\n' % lines[index*4+j].rstrip())


def splitsubig(sample, p_args, meta_dict):
    r1 = []
    r2 = []
    raw_r1_fq = os.path.join(p_args.fastq_dir, meta_dict[sample][0])
    raw_r2_fq = os.path.join(p_args.fastq_dir, meta_dict[sample][1])
    igg_umis = []
    iga_umis = []
    nonsub_umis = []
    nonigg_umis = []
    noniga_umis = []
    c_igg = c_iga = c_non = c_nonigg = c_noniga = 0

    out_r1_fqs = []
    out_r2_fqs = []
    seqtypes = []  # subseqs + short  + undetermined + flc
    igg_r1_fq = os.path.join(p_args.out_dir, 'preprocess', sample + '_subIGG_R1.fastq')
    igg_r2_fq = os.path.join(p_args.out_dir, 'preprocess', sample + '_subIGG_R2.fastq')
    out_r1_fqs.append(igg_r1_fq)
    out_r2_fqs.append(igg_r2_fq)
    seqtypes.append("subIGG")
    iga_r1_fq = os.path.join(p_args.out_dir, 'preprocess', sample + '_subIGA_R1.fastq')
    iga_r2_fq = os.path.join(p_args.out_dir, 'preprocess', sample + '_subIGA_R2.fastq')
    out_r1_fqs.append(iga_r1_fq)
    out_r2_fqs.append(iga_r2_fq)
    seqtypes.append("subIGA")
    nonsub_r1_fq = os.path.join(p_args.out_dir, 'preprocess', sample + '_nonsub_R1.fastq')
    nonsub_r2_fq = os.path.join(p_args.out_dir, 'preprocess', sample + '_nonsub_R2.fastq')
    out_r1_fqs.append(nonsub_r1_fq)
    out_r2_fqs.append(nonsub_r2_fq)
    seqtypes.append("nonsub")
    # only used for debug
    nonigg_r1_fq = os.path.join(p_args.out_dir, 'preprocess', sample + '_nonIGG_R1.fastq')
    nonigg_r2_fq = os.path.join(p_args.out_dir, 'preprocess', sample + '_nonIGG_R2.fastq')
    out_r1_fqs.append(nonigg_r1_fq)
    out_r2_fqs.append(nonigg_r2_fq)
    seqtypes.append("nonIGG")
    noniga_r1_fq = os.path.join(p_args.out_dir, 'preprocess', sample + '_nonIGA_R1.fastq')
    noniga_r2_fq = os.path.join(p_args.out_dir, 'preprocess', sample + '_nonIGA_R2.fastq')
    out_r1_fqs.append(noniga_r1_fq)
    out_r2_fqs.append(noniga_r2_fq)
    seqtypes.append("nonIGA")
    fhs1 = []
    fhs2 = []
    with load_fastq(raw_r1_fq) as f1, load_fastq(raw_r2_fq) as f2, ExitStack() as cm:
        for name in out_r1_fqs:
            fhs1.append(cm.enter_context(open(name, 'a')))
        for name in out_r2_fqs:
            fhs2.append(cm.enter_context(open(name, 'a')))

        for x, y in zip(f1, f2):
            r1.append(x.rstrip())
            r2.append(y.rstrip())
            if len(r1) == 4:
                subseq = get_subseq(r1, p_args.receptor_kit, p_args.species,
                                    pseq_dict, prs, len_cutoff=30, mismatch=1)
                umi = get_umi(r2)
                id1, id2, id3 = get_index(r1)
                if subseq == "TTGACCA":
                    for item in r1:
                        fhs1[seqtypes.index('subIGG')].write('%s\n' % item)
                        #fhs1[seqtypes.index('subIGG')].write('%s\n'[:-1] % item)
                    for item in r2:
                        fhs2[seqtypes.index('subIGG')].write('%s\n' % item)
                    igg_umis.append([umi, id1, id2, id3, c_igg])
                    c_igg +=1
                elif subseq == "CTGGACC":
                    for item in r1:
                        fhs1[seqtypes.index('subIGA')].write('%s\n' % item)
                    for item in r2:
                        fhs2[seqtypes.index('subIGA')].write('%s\n' % item)
                    iga_umis.append([umi, id1, id2, id3, c_iga])
                    c_iga +=1
                else:
                    # only use for debug
                    if subseq == "GGGCCCT":
                        for item in r1:
                            fhs1[seqtypes.index('nonIGG')].write('%s\n' % item)
                        for item in r2:
                            fhs2[seqtypes.index('nonIGG')].write('%s\n' % item)
                        nonigg_umis.append([umi, id1, id2, id3, c_nonigg])
                        c_nonigg +=1
                    elif subseq == "GGGAAGA":
                        for item in r1:
                            fhs1[seqtypes.index('nonIGA')].write('%s\n' % item)
                        for item in r2:
                            fhs2[seqtypes.index('nonIGA')].write('%s\n' % item)
                        noniga_umis.append([umi, id1, id2, id3, c_noniga])
                        c_noniga +=1
                    # end debug
                    for item in r1:
                        fhs1[seqtypes.index('nonsub')].write('%s\n' % item)
                    for item in r2:
                        fhs2[seqtypes.index('nonsub')].write('%s\n' % item)
                    nonsub_umis.append([umi, id1, id2, id3, c_non])
                    c_non +=1
                del r1[:]
                del r2[:]
    igg_umis.sort()
    iga_umis.sort()
    nonsub_umis.sort()
    nonigg_umis.sort()
    noniga_umis.sort()
    save_sortedfastq(igg_umis, igg_r1_fq, igg_r2_fq, p_args)
    save_sortedfastq(iga_umis, iga_r1_fq, iga_r2_fq, p_args)
    save_sortedfastq(nonsub_umis, nonsub_r1_fq, nonsub_r2_fq, p_args)
    save_sortedfastq(nonigg_umis, nonigg_r1_fq, nonigg_r2_fq, p_args)
    save_sortedfastq(noniga_umis, noniga_r1_fq, noniga_r2_fq, p_args)

    meta_dict[sample][0] = sample + '_nonsub_R1_sorted.fastq'
    meta_dict[sample][1] = sample + '_nonsub_R2_sorted.fastq'
    return


def run_system_cmd(cmd, outfile, errfile, err_message, logname='NA'):
    """Function: Run a system command.
    Stores stdout in outfile and stderr in errfile
    err_message is a message to be logged if the command fails
    """
    with open(outfile, 'w') as out, open(errfile, 'w') as err:
        try:
            subprocess.run(cmd.split(), stdout=out, stderr=err, check=True)
        except subprocess.CalledProcessError:
            if logname == 'NA':
                print(err_message)
            else:
                logger = logging.getLogger(logname)
                logger.error(err_message + "\n" + str(err))
            sys.exit(1)
    return


def getsubdirsandfiles(distfd):
    complist = os.listdir(distfd)
    complist.sort()
    dirslist = []
    fileslist = []
    for i in range(len(complist)):
        fullpath = os.path.join(distfd, complist[i])
        if os.path.isfile(fullpath):
            fileslist.append(complist[i])
        elif os.path.isdir(fullpath):
            dirslist.append(complist[i])
    return dirslist, fileslist

def getsubIg_dict(input_dict, subIg):
    temp_dict = {}
    for key, val in input_dict.items():
        if key.find(subIg.upper()) >= 0:
            temp_dict[key] = val
    return temp_dict


def findmatchedpos(seg, subs, fixpos):
    poslist=[]
    pos = seg.find(subs)
    while pos >=0:
        poslist.append(pos)
        pos = seg.find(subs, pos+1)
    if len(poslist)==0:
        l_subs = len(subs)
        temp = subs
        atcg = ["A", "T", "C", "G"]
        count = 0
        while count < l_subs:
            if count != fixpos:
                for i in range(4):
                    temp = subs[:count] + atcg[i] + subs[count+1:]
                    pos = seg.find(temp)
                    while pos>=0:
                        #break
                        if pos not in poslist:
                            poslist.append(pos)
                        pos = seg.find(temp, pos+1)
            count += 1
    poslist.sort()
    if len(poslist) == 0:
        return -1
    else: return poslist[len(poslist)-1]


def get_rightindex(miglines, mig_pos, asslines, ass_pos):
    print("False:")
    print("%s" % miglines[mig_pos+1][:30])
    print("%s" % asslines[ass_pos][:30])
    print("mig_pos=", mig_pos)
    print("ass_pos=", ass_pos)
    if asslines[ass_pos][:8] != "GTACGGGG":
        return mig_pos+4, ass_pos+1
    mig_p = mig_pos
    ass_p = ass_pos
    while miglines[mig_p+1][:30] != asslines[ass_p][:30] and ass_p < ass_pos+30 and ass_p < len(asslines):
        ass_p += 1
    if ass_p < ass_pos+30 and ass_p < len(asslines):
        ass_pos = ass_p
    else:
        while miglines[mig_p+1][:30] != asslines[ass_p][:30] and mig_p < mig_pos+30 and mig_p < len(miglines):
            mig_p += 4
        if mig_p < mig_pos+30 and mig_p < len(miglines):
            mig_pos = mig_p
        else:
            ass_pos += 1
            mig_pos += 4
    print("new mig_pos=", mig_pos)
    print("new ass_pos=", ass_pos)
    return mig_pos, ass_pos


def scanindex(mig1line, mig2line, asslines, p_thread):
    ass_pos =-1
    m2line = mig2line.split('\n')[0]
    m2line = m2line[len(m2line)-16:]
    m1line = mig1line.split('\n')[0]
    m1line = m1line[:16]
    for i in range(1, len(asslines)):
        assline = asslines[i].split('\t')[0]
        pe=findmatchedpos(m2line, assline[len(assline)-16:], -1)
        ps=findmatchedpos(m1line, assline[:16], -1)
        if pe >= 0 and ps >= 0:
            ass_pos = i
            #if ass_pos > p_thread:
            break
    return ass_pos


def getumidict(reads_fq):
    umidect = {}
    l_read = len(reads_fq)
    for i in range(0, l_read, 4):
        umi = reads_fq[i].split(":")[1]
        if umi in umidect.keys():
            print("error")
        umidect[umi] = i
    return umidect


def reverse_complement(seq):
    l_seq = len(seq)
    newseq = ''
    for i in range(l_seq):
        ch = seq[l_seq-1-i]
        if ch == 'A':
            ch = 'T'
        elif ch == 'T':
            ch = 'A'
        elif ch == 'C':
            ch = 'G'
        elif ch == 'G':
            ch = 'C'
        newseq += ch
    return newseq


def get_mergedfqs(p_args, log_name, errfile_name):
    out_log = os.path.join(p_args.out_dir, log_name)
    merge_err = os.path.join(p_args.out_dir, errfile_name)
    print("merged fastq for hybird kit done")


def split_align_unalign_by_readIds(fq_fn, id_fn):
    readsaligned = []
    readsunaligned = []
    with open(fq_fn) as fq_f:
        fqlines = fq_f.readlines()
    with open(id_fn) as ids_f:
        idlines = ids_f.readlines()
    count = 0
    for i in range(1, len(idlines)):
        readId = int(idlines[i])
        for j in range(4):
            readsaligned.append(fqlines[readId*4+j])
        for diff in range(count, readId):
            for j in range(4):
                readsunaligned.append(fqlines[diff*4+j])
        count = readId + 1
    fq_fn_aligned = fq_fn[:len(fq_fn)-6] + "_aligned.fastq"
    fq_fn_unaligned = fq_fn[:len(fq_fn)-6] + "_unaligned.fastq"
    save_list_to_file(fq_fn_aligned, readsaligned, True)
    save_list_to_file(fq_fn_unaligned, readsunaligned, True)


def umi_polyGNs(umi):
    ispolyGs = False
    i = 0
    while i <len(umi) and not ispolyGs:
        if umi[i]=='G' and i+4<len(umi) and umi[i+1] =='G' and umi[i+2] =='G' and umi[i+3] =='G' and umi[i+4] =='G':
            ispolyGs = True
        if umi[i]=='N' and i+4<len(umi) and umi[i+1] =='N' and umi[i+2] =='N' and umi[i+3] =='N' and umi[i+4] =='N':
            ispolyGs = True
        i += 1
    return ispolyGs


def get_adapter_args(p_args):
    adapter_start = 0
    adapter_len = 0
    if p_args.library_kit == 'takara_smartseq':
        if p_args.species == 'human':
            if p_args.receptor_kit == 'TCRv1':
                adapter_start = 8
                adapter_len = 18 #+1
            elif p_args.receptor_kit == 'TCRv2':
                adapter_start = 5
                adapter_len = 21
            elif p_args.receptor_kit == 'BCRv1':
                adapter_start = 0
                adapter_len = 0
            elif p_args.receptor_kit == 'BCRv2':
                adapter_start = 7
                adapter_len = 19 #+5
        elif p_args.species == 'mouse':
            if p_args.receptor_kit == 'TCRv1':
                adapter_start = 7
                adapter_len = 20
            elif p_args.receptor_kit == 'TCRv2':
                adapter_start = 7
                adapter_len = 20
            elif p_args.receptor_kit == 'BCRv1':
                adapter_start = 0
                adapter_len = 0
            elif p_args.receptor_kit == 'BCRv2':
                adapter_start = 7
                adapter_len = 20 #+2
    return adapter_start, adapter_len


def comp_mixcr_report_v3_v4_matrix(v3reportf, v4reportf, receptor):
    v3matrix = []
    v4matrix = []
    results = []
    chains = ['TRA','TRB']
    id_chain = 7
    id_seq = 5
    if receptor == 'BCRv2':
        chains = ['IGG','IGM','IGK','IGL','IGA','IGD','IGE','IGH']
    for i in range(len(chains)) :
        v3matrix.append([])
        v4matrix.append([])
    for i in range(2):
        vf =v3reportf
        if i == 1:
            vf =v4reportf
        with open(vf, mode ='r')as file:
            csvFile = csv.reader(file)
            count = 0
            for line in csvFile:
                if count > 0:
                    chain_type = line[id_chain]
                    seq = line[id_seq]
                    for id in range(len(chains)):
                        if chain_type == chains[id]:
                            if i == 0:
                                v3matrix[id].append(seq)
                            else:
                                v4matrix[id].append(seq)
                count += 1
    for i in range(len(chains)) :
        v3set = set(v3matrix[i])
        v4set = set(v4matrix[i])
        interset = v3set.intersection(v4set)
        overlap = len(interset)
        results.append([len(v3matrix[i]), len(v3set), overlap, len(v4matrix[i]), len(v4set)])
        print(len(v3matrix[i]), len(v3set), overlap, len(v4matrix[i]), len(v4set))
    return results


def plot_multi_bar(results, fb):
    N = 3 * len(results) - 1
    bases = (results[0][2], results[0][2])
    diffs = (results[0][1]-results[0][2], results[0][4]-results[0][2])
    for i in range(1, len(results)):
        bases = bases + (0, results[i][2], results[i][2])
        diffs = diffs + (0, results[i][1]-results[i][2], results[i][4]-results[i][2])
    ind = np.arange(N)
    width = 0.35

    fig = plt.subplots(figsize =(1*N, 7))
    p1 = plt.bar(ind, bases, width)#, yerr = boyStd)
    p2 = plt.bar(ind, diffs, width, bottom = bases)#, yerr = girlStd)

    plt.ylabel('clonotype count')
    tname = os.path.basename(fb).split('_bar.png')[0]
    segs = tname.split('_')
    tname = segs[len(segs)-1]
    if len(results) == 2:
        tname += ' TRA,TRB clonotype count MIXCR v3 vs v4'
        xlab = ('v3TRA','v4TRA','','v3TRB','v4TRB')
    else:
        tname += ' IgG,IgM,IgK,IgL,IgA,IgD,IgE,IgH clonotype count MIXCR v3 vs v4'
        xlab = ('v3IgG','v4IgG','','v3IgM','v4IgM','','v3IgK','v4IgK','','v3IgL','v4IgL','','v3IgA','v4IgA','','v3IgD','v4IgD','','v3IgE','v4IgE','','v3IgH','v4IgH')
    plt.title(tname)
    plt.xticks(ind, xlab)
    #plt.yticks(np.arange(0, 81, 10))
    plt.legend((p1[0], p2[0]), ('bases', 'diffs'))

    f = plt.savefig(fb)
    plt.close(f)


def get_modify_fastq_head(ifd, ifr, barcode, ofd):
    fwname = os.path.joun(ofd, ifr)
    fw = open(fwname, 'w')
    fr = os.path.join(ifd, ifr)
    with open(fr, 'r') as f:
        count = 0
        for line in f:
            count += 1
            if count % 4 == 1:
                segs = line.split(' ')
                newline = segs[0] + '_' + barcode + ' ' + segs[1]
                fw.write(newline)
            else:
                fw.write(line)
    fw.close()


def clonetypes_comparison(fp1, fp2):
    f1 = open(fp1, 'r')
    f2 = open(fp2, 'r')
    flist1 = f1.readlines()
    flist2 = f2.readlines()
    fwlist = flist1.copy()
    count_same = 0
    for j in range (1,len(flist2)):
        segs2 = flist2[j].split(",")
        i = 1
        is_same = False
        while not is_same and i < len(flist1):
            segs1 = flist1[i].split(",")
            if segs2[2]==segs1[2] and segs2[11]==segs1[11] and segs2[13]==segs1[13] and segs2[15]==segs1[15] and segs2[17]==segs1[17]:
                count_same += 1
                is_same = True
            i += 1
        if not is_same:
            fwlist.append(flist2[j])
    fw = fp1.replace('_IGG_', '_IGGMerged_')
    with open(fw, 'w') as f:
        for item in fwlist:
            f.write("%s" % item)
    return count_same, len(flist2)-1-count_same


def dosformat(fpath):
    is_dosformat = False
    f = open(fpath, 'rb')
    line = f.readline()
    if line.find(b'\r\n') >= 0 or line.find(b'\n\r') >= 0 or line.find(b'\r') >= 0:
        is_dosformat = True
    f.close()
    return is_dosformat


def get_index(read):
    line = read[0].split()[0]
    segs = line.split(":")
    num = len(segs)
    return int(segs[num-3]), int(segs[num-2]), int(segs[num-1])


def save_list_to_file(filename, mylist, overwrite):
    if overwrite or not os.path.exists(filename):
        with open( filename, 'w') as fr:
            for i in range(len(mylist)):
                item = mylist[i].split('\n')[0]
                fr.write("%s\n" % item)
        if platform.system() == 'Windows':
            dos2unix( filename)


def get_umis_by_readIds_oldright(p_args, readIds_fpath, sample, subig):
#pre: only for BCRv2hy
    readIdslines = []
    umis = []
    if not os.path.exists(readIds_fpath) :
        return umis
    with open(readIds_fpath, 'r') as readIds_fr:
        for readIdsline in readIds_fr:
            segs = readIdsline.split('\t')
            readIdslines.append(segs[len(segs)-1])
    prefd = os.path.join(p_args.out_dir, 'run_migec', 'assemble')
    prelab = '_R2.t*'
    if p_args.cogentIP_version == 'v2':
        prefd = os.path.join(p_args.out_dir, 'preprocess')
        prelab = '_R1.fastq'
    ig_fpath = find_file(sample + '_' + subig + prelab, prefd)[0]
    with open(ig_fpath, 'r') as ig_fr:
        igfqlines = ig_fr.readlines()
    for i in range(1, len(readIdslines)):
        index_fq = int( readIdslines[i].rstrip() )
        #if index != i-1: print("stop here")
        if p_args.cogentIP_version == 'v2':
           umi_fq = igfqlines[4*index_fq].split(':')[2].split('_umi_')[1]
        else:
           umi_fq = igfqlines[4*index_fq].split(':')[1]
        umis.append(umi_fq)
    return umis


def get_demux_counts_all_csv_fastq(ifpath, ofd):
    ifd = os.path.dirname(ifpath)
    with open(ifpath) as f:
        for line in f:
            segs = line.split(',')
            if len(segs[0]) == 16:
                key = segs[1].replace('_','')
                ifr = 'demux_' + segs[0]+'_'+key+'_R1.fastq.gz'
                get_modify_fastq_head(ifd, ifr, segs[0], ofd)
                ifr = 'demux_' + segs[0]+'_'+key+'_R2.fastq.gz'
                get_modify_fastq_head(ifd, ifr, segs[0], ofd)


def insertmax_returnmin(list_key5max, list_val5max, key_seq, val):
    len_5top = 5
    index = 0
    while index < len_5top and val > list_val5max[index]:
        index += 1
    if index > 0:
        index -= 1
        for i in range(index):
            if i<len_5top:
                list_key5max[i] = list_key5max[i+1]
                list_val5max[i] = list_val5max[i+1]
        list_key5max[index] = key_seq
        list_val5max[index] = val
    return list_key5max[0], list_val5max[0]


def visualize_umi_distribution(p_args, target_range, umi_dict, total, umireads_count):
    numkeys = 5
    list_key5max = ['NNNNNNNNNNNN']*numkeys
    list_val5max = [0]*numkeys
    keymax = list(umi_dict.keys())[0]
    valmax = umi_dict[keymax]
    keymax, valmax = insertmax_returnmin(list_key5max, list_val5max, keymax, valmax)
    for key_umi, val_umicount in umi_dict.items():
        if val_umicount > valmax:
            valmax = val_umicount
            keymax = key_umi
            keymax, valmax = insertmax_returnmin(list_key5max, list_val5max, keymax, valmax)
    umi_summary_f = os.path.join(p_args.fastqRMumi_dir,target_range + '_umi_summary.csv')
    with open(umi_summary_f, 'w') as fw:
        print('total reads: %s' % str(total))
        fw.write('total reads:' + str(total) + '\n')
        print('umi reads: %s' % str(umireads_count))
        fw.write('umi reads:' + str(umireads_count) + '\n')
        print('number of umis: %s' % len(umi_dict.keys()))
        fw.write('number of umis:' + str(len(umi_dict.keys()))+'\n')
        print('top 5 umis=', list_key5max)
        fw.write('top 5 umis=')
        fw.write(','.join(str(item) for item in list_key5max))
        fw.write('\n')
        print('top 5 umis with count=', list_val5max)
        fw.write('top 5 umis with count=')
        fw.write(','.join(str(item) for item in list_val5max))
        fw.write('\n')
    valmax = list_val5max[-1]
    umi_counts = [0] * (valmax+1)
    for key_umi, val_umicount in umi_dict.items():
        umi_counts[ val_umicount ] += 1
    x = [*range(0,valmax+1,1)]
    y = umi_counts
    umi_range_f = os.path.join(p_args.fastqRMumi_dir,target_range + '_umi_distribution.csv')
    with open(umi_range_f, 'w') as fp:
        fp.write('umi_type_numbers,')
        fp.write(','.join(str(item) for item in x))
        fp.write('\n')
        fp.write('frequency,')
        fp.write(','.join(str(item) for item in y))
    drawplot(x, y, umi_range_f[:-4]+'.png')
    return


def drawplot(x, y, fname):
    len_exp = len(y)
    if y[len(y)-1]==1:
        len_exp -=1
    while len_exp>50 and (y[len_exp-1]==0 or y[len_exp-2]==0 or y[len_exp-3]==0 or y[len_exp-4]==0):
        len_exp -=1
    x = x[:len_exp]
    y = y[:len_exp]
    basename = os.path.basename(fname)
    sampleID = basename.split('_')[0]
    setname = 'takara TCR '
    if fname.find('outCellecta') > 0:
        setname = 'cellecta '
    else:
        setname = 'takara '
    if fname.find('TCR') > 0:
        setname += 'TCR '
    else:
        setname += 'BCR '
    for i in range(4):
        plt.plot(x, y)
        plt.xlabel('umi_type_numbers')
        plt.ylabel('frequency of umi_types')
        plt.title('x=umi_types and y=frequency of umi_types with ' + setname + sampleID)
        #plt.xticks(np.arange(0, len_exp, step=20))
        #plt.yticks(np.arange(0, 8000, step=1000))
        if i == 1:
            plt.xlim([0,50])
        if i == 2:
            plt.xlim([0,50])
            plt.ylim([0,20000])
        if i == 3:
            plt.ylim([0,2000])
        fwname = fname[:-4] + str(i) +'.png'
        if i == 0:
            fwname = fname[:-4] + '.png'
        f = plt.savefig(fwname)
        plt.close(f)


def drawUMIdistribution():
    for i in range(9,11):
        frname = 'C:\\Users\\suns\\Downloads\\John_peak\\outmTCRv2ilku1\\John_peak_rmumi\\S'+str(i)+'_umi_distribution.csv'
        fr = open(frname, 'r')
        a = fr.readline().replace('umi_count,', '').split(',')
        b = fr.readline().replace('frequency,', '').split(',')
        fr.close()
        x = [eval(i) for i in a]
        y = [eval(i) for i in b]
        drawplot(x, y, frname[:-4] + '.png')


def splitfastq_by_adapter(sample, fastq_dir, adapterseq):
    r1 = []
    r2 = []
    raw_r1_fq = os.path.join(fastq_dir, sample + "_L001_R1_001.fastq.gz")
    raw_r2_fq = os.path.join(fastq_dir, sample + "_L001_R2_001.fastq.gz")
    out_r1_fqs = []
    out_r2_fqs = []
    prs = ["with-adapter","without-adapter"]

    for directory in prs:
        if not os.path.isdir( os.path.join(fastq_dir, directory) ):
            create_dir(os.path.join(fastq_dir, directory))
        out_r1_fq = os.path.join(fastq_dir, directory, sample + '_L001_R1_001.fastq')
        out_r2_fq = os.path.join(fastq_dir, directory, sample + '_L001_R2_001.fastq')
        out_r1_fqs.append(out_r1_fq)
        out_r2_fqs.append(out_r2_fq)
    for item in out_r1_fqs:
        open(item, 'w+').close()
    for item in out_r2_fqs:
        open(item, 'w+').close()

    fhs1 = []
    fhs2 = []
    with load_fastq(raw_r1_fq) as f1, load_fastq(raw_r2_fq) as f2, ExitStack() as cm:
        for name in out_r1_fqs:
            fhs1.append(cm.enter_context(open(name, 'a')))
        for name in out_r2_fqs:
            fhs2.append(cm.enter_context(open(name, 'a')))

        for x, y in zip(f1, f2):
            r1.append(x.rstrip())
            r2.append(y.rstrip())
            if len(r1) == 4:
                if r1[1].find(adapterseq)>=0 or r2[1].find(adapterseq)>=0:
                    for item in r1:
                        fhs1[0].write('%s\n' % item)
                    for item in r2:
                        fhs2[0].write('%s\n' % item)
                else:
                    for item in r1:
                        fhs1[1].write('%s\n' % item)
                    for item in r2:
                        fhs2[1].write('%s\n' % item)
                del r1[:]
                del r2[:]
    if platform.system() == 'Windows':
        for name in out_r1_fqs:
            dos2unix(name)
        for name in out_r2_fqs:
            dos2unix(name)
    #tar in windows could not correctly compress fastq into fastq.gz
    for directory in prs:
        for f in os.listdir(os.path.join(fastq_dir, directory)):
            if f.endswith('.fastq'):
                fq = os.path.join(fastq_dir, directory, f)
                cmd = 'tar -vczf ' + fq + '.gz ' + fq
                run_system_cmd(cmd, 'run_gzip.log', 'run_gzip.error', 'gzip failed', 'NA')
                os.remove(fq)
    return
